
function isw_saclayMethodTomo, cmbobs, TabGalobs, TabIswspec, cmbspec=cmbspec, Tabgalspec=Tabgalspec,cmbmask=cmbmask,Tabgalmask=Tabgalmask, Tabmbias=Tabmbias, lmin=lmin,lmax=lmax,$
                    inpainting=inpainting,s1iter=s1iter,s1nestiter=sinestiter,s2iter=s2iter,s3iter=s3iter, Res=Res, bootmet= bootmet, method=method, noverb=verb

  if not keyword_set(lmin)  then lmin = 3
  if not keyword_set(lmax)  then lmax = 100

  if not keyword_set(s1iter)     then s1iter = 1000
  if not keyword_set(s1nestiter) then s1nestiter = 1001
  if not keyword_set(s2iter)     then s2iter = 10000
  if not keyword_set(s3iter)     then s3iter = 10000
  if not keyword_set(bootmet)     then bootmet = 1
  if not keyword_set(method)     then method = 0


  ;; Perform CMB inpainting if the mask is given
  if keyword_set(cmbmask) and keyword_set(inpainting) then begin
     cmbinpaint = mrs_alm_inpainting(cmbobs*cmbmask,mask=cmbmask,opt='-i40 -v')
     cmbobs = cmbinpaint
  endif

  ;; Perform matter over-density inpainting from galaxy survey if the mask is give
  vs = size(TabGalobs)
  NbrSurvey = vs[2]
  if not keyword_set(Tabmbias) then Tabmbias = fltarr(NbrSurvey) + 1.0d

  if keyword_set(galmask) and keyword_set(inpainting) then begin
     for i=0, NbrSurvey-1 do begin
         galobs = TabGalobs[*,i]
         galinpaint = mrs_alm_inpainting(galobs*galmask,mask=galmask,opt='-v -i40 -T -C -p')
         galmean = mean(galinpaint)
         galobs = (galintpaint - galmean)/galmean / Tabmbias[i]
         TabGalobs[*,i] = galobs
     endfor
  endif

  ;; First step: correlation detection
t1 = isw_corrTestTomo(cmbobs, TabGalobs, NbrSurvey, method=method, lmin=lmin, lmax=lmax,bootstrap=s1iter,btstpvar=1001,bootmet= bootmet,/noverb)
print,'First step: correlation detection'
print,'p-value =',t1.pvalue
print,'sigma = ',inverf(1.0d - t1.pvalue)*sqrt(2.0d)

  ;; Second step: signal detection / amplitude estimation
  t2 = isw_estAmplTomo(cmbobs, TabGalobs, NbrSurvey, iswspec=TabIswspec,cmbspec= cmbspec,galspec=Tabgalspec,lmin=lmin,lmax=lmax,bootstrap=s2iter,btspvar=0,/usemc, /noverb)
  print,'Second step: amplitude estimation (aka signal detection)'
  print,'p-value =',t2.pvalue
  print,'sigma = ',inverf(1.0d - t2.pvalue)*sqrt(2.0d)

  ;; Third and final step: model selection
  t3 = isw_testModelTomo(cmbobs, TabGalobs,NbrSurvey, iswspec=TabIswspec, cmbspec=cmbspec, galspec=Tabgalspec, lmin=lmin,lmax=lmax,bootstrap=s3iter,/noverb)
  print,'Third step: model selection'
  print,'p-value =',t3.pvalue
  print,'sigma = ',inverf(1.0d - t3.pvalue)*sqrt(2.0d)

Res = {Test1: t1, Test2: t2, Test3: t3, NsigmaTest1: inverf(1.0d - t1.pvalue)*sqrt(2.0d),  $
                                                      NsigmaTest2:  inverf(1.0d - t2.pvalue)*sqrt(2.0d),  $
                                                      NsigmaTest3:  inverf(1.0d - t3.pvalue)*sqrt(2.0d)}
return, Res
end


;=============================================================================


