;
; Pour calculer le support multi-résolution, il faut bien initialiser l'environnement
;; .r ../icosmo_v1.4/fx/tag_exist
;; .r mrs_alm_inpainting
;; .r mrs_alias
;; .r ../poissoninp/mrs_msvsts_IUWT_transform
;; .r ../poissoninp/mrs_msvsts_IUWT_param_computing
;; .r ../poissoninp/mrs_msvsts_IUWT_hypothesis_testing
;; .r ../poissoninp/mrs_msvsts_IUWT_denoising
;
pro fx_testgal

  ;; Global environnement variables
  DEF_ALM_FAST  = 0  ;; Work with double
  DEF_ALM_NITER = 1  ;; Be soft with the alm transform (but not always, because it is a very big shit)

  ;; My other variables
  nside  = 64
  nslmax = 100

  ;; galima = rims('~/IDL/Work/2mass_map_32.fits')
  ;; galmask = rims('~/IDL/Work/2mass_mask_32.fits')
  galima = rims('~/IDL/Work/2mass_map_64.fits')
  galmask = rims('~/IDL/Work/2mass_mask_64.fits')
  ;; galima = rims('~/IDL/Work/2mass_map_128.fits')
  ;; galmask = rims('~/IDL/Work/2mass_mask_128.fits')
  ;; galima = rims('~/IDL/Work/2mass_map_256.fits')
  ;; galmask = rims('~/IDL/Work/2mass_mask_256.fits')
  ;; galmask = rims('~/IDL/Data/2mass_mask_512.fits')
  ;; galima = rims('~/IDL/Data/2mass_survey_512.fits')

  ;; galima  = rims('~/IDL/Work/nvss_map3p4mJ_128.fits')
  ;; galmask = rims('~/IDL/Work/nvss_mask_256.fits')
  ;; cmbmask = rims('~/IDL/Data/wmap_temperature_analysis_mask_r9_7yr_v4.fits')

  ;; ud_grade,cmbmask,cmask,nside_out=nside,order_in='nested'
  ;; ud_grade,galmask,mask,nside_out=nside,order_in='nested'
  ;; mask = mask * cmask
  ;; galindex = where(mask ne 1.0)
  ;; mask[galindex] = 0.0d

  mask = galmask
  ima  = galima

  ;; ud_grade,cmbmask,cmask,nside_out=256,order_in='nested'
  ;; ud_grade,galmask,mask,nside_out=nside,order_in='nested'

  ;; mask = mask * cmask
  galindex = where(mask eq 1.0)
  makindex = where(mask ne 1.0)
  mask[makindex] = 0.0d

  ;; ud_grade,galima,ima,nside_out=nside,order_in='nested'

  ;; x = newsimu(survey=2,nside=nside)
  lmax = 120

  ;; cmbspec = dblarr(lmax+1)
  ;; iswspec = dblarr(lmax+1)
  ;; galspec = dblarr(lmax+1)
  ;; cmbspec[1:lmax] = interpol(x.x.x_nocor.ctt_original.cl,x.x.x_nocor.ctt_original.l,fix(findgen(lmax)+1))
  ;; galspec[1:lmax] = interpol(x.x.x_nocor.cgg_original.cl,x.x.x_nocor.cgg_original.l,fix(findgen(lmax)+1))
  ;; iswspec[1:lmax] = interpol(x.x.x_cor.cgt_original.cl,x.x.x_cor.cgt_original.l,fix(findgen(lmax)+1))
  ;; save,filename='specEuclid.xdr',galspec,iswspec,cmbspec
  restore,'spec2mass.xdr',/verb
  
  galspec = galspec * (1.3d)^2

  imagcor = fx_newsimu(galspec,/lognormal,nside=nside,lmax=lmax)
  g_true  = (imagcor + 1.0d) * 30d
  g_poisson = g_true
  for i=0ul,nside2npix(nside)-1 do if g_true[i] le 0 then g_poisson[i] = 0.0d else g_poisson[i] = randomn(seed,poisson=g_true[i],/double)

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Inpainting 2MASS data
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  ;; Compute a first estimate of the power spectra
  idens = (ima - mean(ima[galindex])) / mean(ima[galindex]) * mask
  pdens = (ima - mean(ima)) / mean(ima)
  nspec = mrs_powspec(pdens,/nonorm,lmax=lmax)
  pspec = fx_master_powspec(idens,mask,lmax=lmax) ;; Use MASTER to recover the power spectra of the overdensity field

  ;; Inpaint using previous method
  titi  = mrs_alm_inpainting(ima*mask,mask=mask,opt='-v -i40 -T -C -p')
  titi  = (titi - mean(titi)) / mean(titi)
  ;; pspec = mrs_powspec(titi,/nonorm,lmax=lmax)

  ;; tspec = blk_con([1,1,1,1,1],transpose(pspec),B_length=10) / 5.0d ;; Smoothing the estimated power-spectra ad-hoc solution

  ;; Inpaint the data
  ;; ima_inp  = fx_galaxyInpaint(ima*mask,mask=mask,pspec=tspec,nbIter=100,lmax=200,/verb,beta=1.5d,gmean=6.4d,fixlbd=1.0d-13,nbem=5,nbmi=1,nbtex=15,/updatespec,NbrScale=6,support=tsupport,method=1)
  ;; ima_inp = fx_galaxyInpaint(ima*mask,mask=mask,pspec=tspec,nbIter=100,lmax=200,/verb,beta=1.5d,gmean=6.4d,fixlbd=1.0d-13,nbem=5,nbmi=5,nbtex=5,/updatespec,NbrScale=6,support=tsupport,/eststop)

  ;; Inpainting configuration for NSIDE=256
  ; nbtex = nbr d'iter pour la synthese de texture
  ; nbem = nbr iterations EM. si nbem = 0, alors pas d'inpainting (maximum de vraissemblence) = kitaura method
  ; tau = thoeriquement l'inverse de la plus grande valeur du spectre
  ima_inp      = fx_galaxyInpaint(ima*mask,mask=mask,pspec=pspec,nbIter=500,lmax=lmax,/verb, tau=0.0002d,  nbem=5, nbtex=5)
  ima_inp.spec = mrs_powspec(ima_inp.est,/nonorm,lmax=lmax)

  ;; Plot the different power spectra and which one is the more interesting
  plotcl,nspec,color=0,background=1,xrange=[0,lmax]   ;; Black
  oplotcl,pspec,color=4                               ;; Blue
  oplotcl,galspec,color=2                             ;; Red
  ;;oplotcl,tspec,color=3                               ;; Green
  oplotcl,ima_inp.spec,color=6                        ;; Violet/Purple

  ti1 = tol(ima_inp.est - mean(ima_inp.est),nslmax)
  ti2 = tol(titi,nslmax)

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Denoising (on simulation)
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  ;; Use our denoising for log-normal field
  realspec = mrs_powspec(imagcor,/nonorm,lmax=lmax)
  pspec    = mrs_powspec((g_poisson - 30d)/30d,/nonorm,lmax=lmax)
  tspec    = blk_con([1,1,1,1,1],transpose(pspec),B_length=30) / 5.0d
  
  ;; t2      = fx_galaxyInpaint(g_poisson,pspec=tspec,nbIter=500,lmax=120,/verb,gmean=25d,updatespec=0,eststop=0,nbPSem=1,tau=0.0002d)   ;; nside=64
  t2      = fx_galaxyInpaint(g_poisson,pspec=galspec,nbIter=500,lmax=200,/verb,gmean=6.0d,updatespec=0,eststop=0,nbPSem=1,tau=0.001d) ;; nside=128
  t2.spec = mrs_powspec(t2.est,/nonorm,lmax=lmax)

  ;; Plotting the denoising results
  window,0
  plot,[0,3],[0,3],color=0,background=1
  oplot,tol(t2.est,nslmax),tol(imagcor,nslmax),color=3,psym=4

  window,1
  plot,[0,3],[0,3],color=0,background=1
  oplot,tol((g_poisson - mean(g_poisson)) / mean(g_poisson),nslmax),tol(imagcor,nslmax),color=2,psym=4

  ;; Plot the power spectra
  window,2
  plotcl,pspec,color=0,background=1
  oplotcl,galspec,color=2
  oplotcl,realspec,color=4
  oplotcl,t2.spec,color=3

  ;; MSE
  npix = double(nside2npix(nside))
  ti1  = tol(t2.est,nslmax)
  ti2  = tol((g_poisson - mean(g_poisson)) / mean(g_poisson),nslmax)
  ti3  = tol(imagcor,nslmax)

  print,'Observation MAE error ',total(abs(ti2 - ti3)) / npix
  print,'Estimation MAE (M1)',total(abs(ti1 - ti3)) / npix

  print,'Observation MSE error ',total((abs(ti2 - ti3))^2) / npix
  print,'Estimation MSE (M1)',total((abs(ti1 - ti3))^2) / npix

  print,'Observation PSNR ',10.0d * alog(max(ti3) / (total((abs(ti2 - ti3))^2) / npix))
  print,'Estimation PSNR (M1)',10.0d * alog(max(ti3) / (total((abs(ti1 - ti3))^2) / npix))

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Inpainting with simulated data
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  ;; Use another code for initialization
  ;; mrs_msvsts_IUWT_denoising,x.g_poisson*mask,msrecon,NbrScale=6,niter=40,/HSD,coef_seuil=2 ;;,/update_support
  ;; titi = mrs_alm_inpainting(msrecon*mask, mask=mask, opt='-v -i40 -T -C -p')

  ;; Compute a first estimate of the power spectra
  idens = (g_poisson - mean(g_poisson[galindex])) / mean(g_poisson[galindex]) * mask
  pdens = (g_poisson - mean(g_poisson)) / mean(g_poisson)
  nspec = mrs_powspec(pdens,/nonorm,lmax=lmax)
  pspec = fx_master_powspec(idens,mask,lmax=lmax) ;; Use MASTER to recover the power spectra of the overdensity field

  titi = mrs_alm_inpainting(g_poisson*mask, mask=mask, opt='-v -i40 -T -C -p')
  titi = (titi - mean(titi)) / mean(titi)
  mcaspec = mrs_powspec(titi,/nonorm,lmax=lmax)
  realspe = mrs_powspec(imagcor,/nonorm,lmax=lmax)

  tspec = blk_con([1,1,1,1,1],transpose(pspec),B_length=30) / 5.0d ;; Smoothing the estimated power-spectra ad-hoc solution
 
  ;; Inpaint the data
  ;; toto  = fx_galaxyInpaint(x.g_poisson*mask,mask=mask,pspec=tspec,nbIter=100,lmax=200,/verb,tau=0.005d,gmean=10.0d,fixlbd=1.0d-13,nbem=1,nbmi=1,nbtex=5,/updatespec,NbrScale=6,coef_seuil=7,/support,/eststop,nbPSem=5)
  toto = fx_galaxyInpaint(g_poisson*mask,mask=mask,pspec=pspec,nbIter=500,lmax=100,/verb,tau=0.0002d,gmean=30d,nbem=5,nbmi=1,nbtex=10,updatespec=0,eststop=1,nbPSem=1)
  ;; toto = fx_galaxyInpaint(g_poisson*mask,mask=mask,pspec=galspec,nbIter=500,lmax=120,/verb,tau=0.0002d,gmean=25d,nbem=2,nbmi=1,nbtex=5,updatespec=0,eststop=0,nbPSem=1)
  toto.spec = mrs_powspec(reform(toto.est),/nonorm,lmax=100)
 
  ;; Plot the different power spectra and which one is the more interesting
  window,1
  plotcl,nspec,color=0,background=1,xrange=[0,100]   ;; Black
  oplotcl,galspec,color=2                            ;; Red
  oplotcl,pspec,color=3                              ;; Green
  oplotcl,realspe,color=4                            ;; Blue
  oplotcl,mcaspec,color=5                            ;; Cyan
  oplotcl,toto.spec,color=6                          ;; Violet/Purple

  npix = double(nside2npix(nside))
  ;; ti1  = tol(reform(toto.est[*,0]),nslmax)
  ti1 = tol(toto.est - mean(toto.est),nslmax)
  ti2 = tol(titi,nslmax)
  ti3 = tol(imagcor,nslmax)

  print,'Observation MAE error ',total(abs(ti2 - ti3)) / npix
  print,'Estimation MAE (M1)',total(abs(ti1 - ti3)) / npix

  print,'Observation MSE error ',total((abs(ti2 - ti3))^2) / npix
  print,'Estimation MSE (M1)',total((abs(ti1 - ti3))^2) / npix

  print,'Observation PSNR ',10.0d * alog(max(ti3) / (total((abs(ti2 - ti3))^2) / npix))
  print,'Estimation PSNR (M1)',10.0d * alog(max(ti3) / (total((abs(ti1 - ti3))^2) / npix))

  ;; Plotting the denoising results
  ;; iindex = galindex
  iindex = indgen(npix)
  window,0
  plot,[0,3],[0,3],color=0,background=1
  oplot,ti1[iindex],ti3[iindex],color=3,psym=4

  window,1
  plot,[0,3],[0,3],color=0,background=1
  oplot,ti2[iindex],ti3[iindex],color=2,psym=4

  ;; write_fits_map,'2mass_inp_new_512.fits',toto,/nested
  ;; window
  ;; plotcl,mrs_powspec(ti1,/nonorm,lmax=nslmax),color=0,background=1
  ;; oplotcl,galspec,color=2
  ;; oplotcl,mrs_powspec(ti2,/nonorm,lmax=nslmax),color=3

  stop

end
